Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class UncommittedLibraryObjectDataCache

    java.lang.Object
      oracle.ifs.common.Cache
          oracle.ifs.server.UncommittedLibraryObjectDataCache

    public final class UncommittedLibraryObjectDataCache

extends Cache

An UncommittedLibraryObjectDataCache caches S_LibraryObjectData objects for an S_LibrarySession.

Unlike the committed data cache maintained by S_LibraryService (which shares data across all sessions for that service), an UncommittedLibraryObjectDataCache provides a session-wise transaction-aware data cache.

Field Summary
`protected LooselyBoundedCache` | `m_CommittedLibraryObjectDataCache` The committed data cache belonging to S_LibraryService.
`protected java.util.Vector` | `m_Frames` The uncommitted data frames (one for each savepoint).
`protected long` | `m_HitCount` The number of cache hits.
`protected long` | `m_MissCount` The number of cache misses.
`protected long` | `m_PutCount` The number of cache puts.
`protected long` | `m_RemoveCount` The number of cache removes.
`protected S_LibrarySession` | `m_Session` The session to which this UncommittedLibraryObjectDataCache belongs.

Fields inherited from class oracle.ifs.common.Cache
`m_Configuration`

Constructor Summary
`UncommittedLibraryObjectDataCache(UncommittedLibraryObjectDataCacheConfiguration config)` Constructs an uncommitted data cache.

Method Summary
`protected void` | `abortTransaction(Transaction transaction)` Handles the cache implications of aborting a transaction.
`protected void` | `beginTransaction(Transaction transaction)` Handles the cache implications of beginning a new transaction.
`protected void` | `completeTransaction(Transaction transaction, LibraryConnection lconn)` Handles the cache implications of completing a transaction.
`void` | `dispose()` Disposes this cache.
`java.lang.Object` | `find(java.lang.Object id)` Gets an item from this cache.
`CachePerformance` | `getCachePerformance()` Gets the performance information for this cache.
`protected void` | `invalidateSharedState(IfsEvent event)` Invalidates shared state for the specified object.
`void` | `lock(java.lang.Object id, java.lang.Object value)` Puts an item in this cache, locking it if it represents committed data.
`void` | `lock(java.lang.Object id, S_LibraryObjectData lodata)` Puts an item in this cache, locking it if it represents committed data.
`protected void` | `markDirty(java.lang.Long id, java.lang.Long classId, int eventType)` Marks the specified S_LibraryObjectData as being "dirty".
`void` | `put(java.lang.Object id, java.lang.Object value)` Puts an item in this cache.
`void` | `put(java.lang.Object id, S_LibraryObjectData lodata)` Puts an item in this cache.
`void` | `remove(java.lang.Object id)` Removes an item from this cache.
`void` | `reset()` Resets this cache.
`void` | `resetCachePerformance()` Resets the performance information for this cache.
`protected void` | `scheduleEvent(IfsEvent event)` Schedules a committed or rolled-back event for the specified uncommitted event.
`protected void` | `scheduleRawAuditEvent(AuditExecutor.PreparedRawAuditEvent rawEvent, int postMode)` Schedules an AuditEvent, to be created as success if the transaction completes normally, or as a failure if the transaction aborts.
`void` | `setCacheConfiguration(CacheConfiguration config)` Alters the configuration of this cache.

Methods inherited from class oracle.ifs.common.Cache
`getCacheConfiguration, getElements`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_Session

    protected S_LibrarySession m_Session

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The session to which this UncommittedLibraryObjectDataCache belongs.

### m_CommittedLibraryObjectDataCache

    protected LooselyBoundedCache m_CommittedLibraryObjectDataCache

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The committed data cache belonging to S_LibraryService.

### m_Frames

    protected java.util.Vector m_Frames

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The uncommitted data frames (one for each savepoint).

### m_HitCount

    protected long m_HitCount

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The number of cache hits.

### m_MissCount

    protected long m_MissCount

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The number of cache misses.

### m_PutCount

    protected long m_PutCount

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The number of cache puts.

### m_RemoveCount

    protected long m_RemoveCount

  Description copied from class: `UncommittedLibraryObjectDataCache`
  The number of cache removes.

Constructor Detail

### UncommittedLibraryObjectDataCache

    public UncommittedLibraryObjectDataCache(UncommittedLibraryObjectDataCacheConfiguration config)
                                      throws IfsException

  Constructs an uncommitted data cache.

  Parameters:
    `config` - the configuration paramaters for the new cache
  Throws:
    `IfsException` - if the operation fails

Method Detail

### setCacheConfiguration

    public final void setCacheConfiguration(CacheConfiguration config)
                                     throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Alters the configuration of this cache.

  No configuration parameters of an UncommittedLibraryObjectDataCache are updateable. Consequently, this method is a no-op.

  Specified by:
    `setCacheConfiguration` in class `Cache`
  Parameters:
    `config` - the configuration parameters
  Throws:
    `IfsException` - if the operation fails

### put

    public final void put(java.lang.Object id,
                          java.lang.Object value)
                   throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Puts an item in this cache.

  Specified by:
    `put` in class `Cache`
  Parameters:
    `id` - the item id
    `value` - the item
  Throws:
    `IfsException` - if operation fails

### put

    public final void put(java.lang.Object id,
                          S_LibraryObjectData lodata)
                   throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Puts an item in this cache.

  Parameters:
    `id` - the item id
    `lodata` - the S_LibraryObjectData
  Throws:
    `IfsException` - if operation fails

### lock

    public final void lock(java.lang.Object id,
                           java.lang.Object value)
                    throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Puts an item in this cache, locking it if it represents committed data.

  Parameters:
    `id` - the item id
    `value` - the item
  Throws:
    `IfsException` - if operation fails

### lock

    public final void lock(java.lang.Object id,
                           S_LibraryObjectData lodata)
                    throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Puts an item in this cache, locking it if it represents committed data.

  Parameters:
    `id` - the item id
    `lodata` - the S_LibraryObjectData
  Throws:
    `IfsException` - if operation fails

### remove

    public final void remove(java.lang.Object id)
                      throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Removes an item from this cache.

  Specified by:
    `remove` in class `Cache`
  Parameters:
    `id` - the item id
  Throws:
    `IfsException` - if operation fails

### find

    public final java.lang.Object find(java.lang.Object id)
                                throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Gets an item from this cache.

  Specified by:
    `find` in class `Cache`
  Parameters:
    `id` - the item id
  Returns:
    the item, or null if the item is not in this cache
  Throws:
    `IfsException` - if operation fails

### getCachePerformance

    public final CachePerformance getCachePerformance()

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Gets the performance information for this cache.

  Specified by:
    `getCachePerformance` in class `Cache`
  Returns:
    a cache performance object

### resetCachePerformance

    public final void resetCachePerformance()

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Resets the performance information for this cache.

  Specified by:
    `resetCachePerformance` in class `Cache`

### reset

    public void reset()

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Resets this cache.

  This causes the cache to be emptied and its performance information to be reset.

  Overrides:
    `reset` in class `Cache`

### dispose

    public void dispose()

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Disposes this cache.

  After the cache is disposed, it is invalid to use this cache.

  Overrides:
    `dispose` in class `Cache`

### scheduleEvent

    protected final void scheduleEvent(IfsEvent event)
                                throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Schedules a committed or rolled-back event for the specified uncommitted event.

  Parameters:
    `event` - the uncommitted event
  Throws:
    `IfsException` - if the operation fails

### scheduleRawAuditEvent

    protected final void scheduleRawAuditEvent(AuditExecutor.PreparedRawAuditEvent rawEvent,
                                               int postMode)
                                        throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Schedules an AuditEvent, to be created as success if the transaction completes normally, or as a failure if the transaction aborts.

  Parameters:
    `rawEvent` - the raw audit event
    `postMode` - the post mode for the event
  Throws:
    `IfsException` - if the operation fails

### markDirty

    protected final void markDirty(java.lang.Long id,
                                   java.lang.Long classId,
                                   int eventType)
                            throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Marks the specified S_LibraryObjectData as being "dirty".

  Parameters:
    `id` - the id
    `classId` - the class id
    `eventType` - the event type that caused the data to be dirty
  Throws:
    `IfsException` - if the operation fails

### invalidateSharedState

    protected void invalidateSharedState(IfsEvent event)
                                  throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Invalidates shared state for the specified object.

  Parameters:
    `event` - event causing shared state invalidation
  Throws:
    `IfsException` - if the operation fails

### beginTransaction

    protected final void beginTransaction(Transaction transaction)
                                   throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Handles the cache implications of beginning a new transaction.

  Parameters:
    `transaction` - the new transaction
  Throws:
    `IfsException` - if the operation fails

### abortTransaction

    protected final void abortTransaction(Transaction transaction)
                                   throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Handles the cache implications of aborting a transaction.

  Parameters:
    `transaction` - the transaction
  Throws:
    `IfsException` - if the operation fails

### completeTransaction

    protected final void completeTransaction(Transaction transaction,
                                             LibraryConnection lconn)
                                      throws IfsException

  Description copied from class: `UncommittedLibraryObjectDataCache`
  Handles the cache implications of completing a transaction.

  Parameters:
    `transaction` - the transaction
    `lconn` - a writeable library connection to use for posting audit events, or null to use an auxiliary connection
  Throws:
    `IfsException` - if the operation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD